/*
 * Copyright (c) 2005 TopCoder, Inc., All Rights Reserved
 */
package com.topcoder.network.synchronization.defaultimpl.transfer;

import com.topcoder.network.synchronization.bean.PeerGroupInfo;
import com.topcoder.network.synchronization.protocol.MessageListener;
import com.topcoder.network.synchronization.protocol.MessageReceiver;

/**
 * Receive messages from the peer group using UDP protocol.
 * 
 * It uses MulticastSocket and DatagramPacket classes to send broadcast messages. In most current network and OS, 
 * the maximum size of UDP data packet is 8K, so to receive a single packet, a buffer with 8K length is
 * enough. As described in the *Sender* section, the receiver should assemble the original message if it received 
 * all the packets of that message.
 * 
 * @author TCSDESIGNER
 * @version 1.0
 */
public class MessageReceiverImpl implements MessageReceiver {
    
    /**
     * Represents the first message listener in ths receiver
     */
    private MessageListener first = null;
    
    /**
     * Represents the last message listener in this receiver
     */
    private MessageListener last = null;

    /**
     * Add a listener to this receiver.
     * The added listener will be added to this listener chain in this receiver.
     * When a message received, the listeners will be called one by one to deal this messages.   
     * 
     * @param listener the listener to add
     */
    public void addMessageListener(MessageListener listener) {
        // TODO Auto-generated method stub

    }
    
    /**
     * Return ths first MessageListener of this receiver.
     *  
     * @return ths first MessageListener of this receiver
     */
    public MessageListener getMessageListener() {
        // TODO Auto-generated method stub
        return null;
    }
    
    /**
     * Remove the listener of this receiver.
     * 
     * @param listener the listener to remove  
     */
    public void removeMessageListener(MessageListener listener) {
        // TODO Auto-generated method stub

    }
    
    /**
     * Remove all message listeners from this receiver. 
     *
     */
    public void clearMessageListeners() {
        
    }
    
    /**
     * 
     * Set the PeerGroupInfo of this receiver.
     * the PeerGroupInfo is used to tell the receiver where the message should be received.
     * 
     * @param groupInfo the PeerGroupInfo of this receiver  
     * 
     */
    public void setPeerGroupInfo(PeerGroupInfo groupInfo) {
        // TODO Auto-generated method stub

    }

    /**
     * Return the PeerGroupInfo of this receiver.
     * @return the PeerGroupInfo of this receiver.
     */
    public PeerGroupInfo getPeerGroupInfo() {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * Stop this receiver.
     *
     */
    public void stop() {
        // TODO Auto-generated method stub

    }

    /**
     * This method start a new thread to listen to the address of 
     * the peer group specified. And it receives the packets and constructs
     * the message and pass it to the first message listener.
     */
    public void run() {
        // TODO Auto-generated method stub

    }

}
