/*
 * Copyright (c) 2005 TopCoder, Inc., All Rights Reserved
 */
package com.topcoder.network.synchronization.defaultimpl.transfer;

import com.topcoder.network.synchronization.bean.Message;
import com.topcoder.network.synchronization.bean.PeerGroupInfo;
import com.topcoder.network.synchronization.exception.DistributedProtocolException;
import com.topcoder.network.synchronization.protocol.MessageSender;

/**
 * Send messages to the peer group using UDP protocol. 
 * 
 * Implementation note:
 * It uses MulticastSocket and DatagramPacket classes to send broadcast messages.
 * In most current network and OS, the maximum size of UDP data packet is 8K, so one large message should be splitted 
 * into smaller packets if necessary.
 * 
 * Because UDP protocol is unreliable,  each small packet of a large message should specify the messageId, 
 * messagePacketNumber, and messagePacketIndex at the head of it. So that the receiver can assemble the original message 
 * if it received all the packets of that message.
 * 
 * 
 * @author TCSDESIGNER
 * @version 1.0
 */
public class MessageSenderImpl implements MessageSender {

    /**
     * Set the PeerGroupInfo of this sender.
     * the PeerGroupInfo is used to tell the sender where the message should be sended.
     * 
     * @param groupInfo the PeerGroupInfo of this sender  
     */
    public void setPeerGroupInfo(PeerGroupInfo groupInfo) {
        // TODO Auto-generated method stub

    }

    /**
     * Return the PeerGroupInfo of this sender.
     * 
     * @return the PeerGroupInfo of this sender.
     */
    public PeerGroupInfo getPeerGroupInfo() {
        // TODO Auto-generated method stub
        return null;
    }

    /**
     * Set the timeout of this sender. 
     * If one message can't be sended in timeout millseconds, the message is failed to send.
     * 
     * @param timeout the timeout of this sender.
     */
    public void setTimeout(int timeout) {
        // TODO Auto-generated method stub

    }

    /**
     * Return the timeout of this sender. 
     * If one message can't be sended in timeout millseconds, the message is failed to send.
     * 
     * @return the timeout of this sender.
     */
    public int getTimeout() {
        // TODO Auto-generated method stub
        return 0;
    }

    /**
     * Send the message to the peer group.
     * Usually, each peer of this peer group will receive this message.
     * 
     * Implementation note:
     * It uses MulticastSocket and DatagramPacket classes to send broadcast messages.
     * In most current network and OS, the maximum size of UDP data packet is 8K, so one large message should be splitted 
     * into smaller packets if necessary.
     * 
     * Because UDP protocol is unreliable,  each small packet of a large message should specify the messageId, 
     * messagePacketNumber, and messagePacketIndex at the head of it. So that the receiver can assemble the original message 
     * if it received all the packets of that message.
     * 
     * @param message the message to send
     * @throws DistributedProtocolException if fails to send the message
     */
    public void send(Message message) throws DistributedProtocolException {
        // TODO Auto-generated method stub

    }

}
